package producetracker;

import java.util.ArrayList;

public class Inventory {

    private ArrayList<Item> stock;

    private Item find(String name) {
        for (int n = 0; n < stock.size(); n++) {
            Item i = stock.get(n);
            if (i.isMyName(name)) {
                return i;
            }
        }
        return null;
    }

    private boolean exists(String name) {
        for (int n = 0; n < stock.size(); n++) {
            Item i = stock.get(n);
            if (i.isMyName(name)) {
                return true;
            }
        }
        return false;
    }

    public Inventory() {
        stock = new ArrayList<Item>();
    }

    public void addItems(String item, int howMany) {
        // When some items come in, we first need to see if those items
        // are already in our stock list
        if (exists(item)) {
            Item existingItem = find(item);
            existingItem.increaseQuantity(howMany);
        } else {
            Item newItem = new Item(item);
            newItem.increaseQuantity(howMany);
            stock.add(newItem);
        }
    }

    public void removeItems(String item, int howMany) {
        Item existingItem = find(item);
        existingItem.decreaseQuantity(howMany);
        if (existingItem.isNoneLeft()) {
            stock.remove(existingItem);
        }
    }

    public void printReport() {
        for (int n = 0; n < stock.size(); n++) {
            Item i = stock.get(n);
            System.out.println(i);
        }
    }
}
